"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const helpers_1 = require("./helpers");
function BodiedNode(Base) {
    return class extends Base {
        getBody() {
            const body = this.compilerNode.body;
            if (body == null)
                throw new errors.InvalidOperationError("Bodied node should have a body.");
            return this._getNodeFromCompilerNode(body);
        }
        setBodyText(textOrWriterFunction) {
            const body = this.getBody();
            helpers_1.setBodyTextForNode(body, textOrWriterFunction);
            return this;
        }
        getBodyText() {
            return helpers_1.getBodyTextWithoutLeadingIndentation(this.getBody());
        }
    };
}
exports.BodiedNode = BodiedNode;
