"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../../../utils");
/**
 * @internal
 */
function getBodyTextWithoutLeadingIndentation(body) {
    const sourceFile = body._sourceFile;
    const textArea = body.getChildSyntaxList() || body; // arrow functions don't have a syntax list
    const startPos = textArea.getNonWhitespaceStart();
    const endPos = Math.max(startPos, textArea._getTrailingTriviaNonWhitespaceEnd());
    const width = endPos - startPos;
    if (width === 0)
        return "";
    const fullText = sourceFile.getFullText().substring(startPos, endPos);
    return utils_1.StringUtils.indent(fullText, -1 * textArea.getIndentationLevel(), textArea._context.manipulationSettings.getIndentationText(), pos => sourceFile.isInStringAtPos(pos + startPos));
}
exports.getBodyTextWithoutLeadingIndentation = getBodyTextWithoutLeadingIndentation;
