"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const manipulation_1 = require("../../../../manipulation");
const typescript_1 = require("../../../../typescript");
const getBodyText_1 = require("./getBodyText");
/**
 * @internal
 */
function setBodyTextForNode(body, textOrWriterFunction) {
    const newText = getBodyText_1.getBodyText(body._getWriterWithIndentation(), textOrWriterFunction);
    const openBrace = body.getFirstChildByKindOrThrow(typescript_1.SyntaxKind.OpenBraceToken);
    const closeBrace = body.getFirstChildByKindOrThrow(typescript_1.SyntaxKind.CloseBraceToken);
    manipulation_1.insertIntoParentTextRange({
        insertPos: openBrace.getEnd(),
        newText,
        parent: body,
        replacing: {
            textLength: closeBrace.getStart() - openBrace.getEnd()
        }
    });
}
exports.setBodyTextForNode = setBodyTextForNode;
