"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../../../utils");
function ReferenceFindableNode(Base) {
    return class extends Base {
        findReferences() {
            return this._context.languageService.findReferences(getNodeForReferences(this));
        }
        findReferencesAsNodes() {
            return this._context.languageService.findReferencesAsNodes(getNodeForReferences(this));
        }
    };
}
exports.ReferenceFindableNode = ReferenceFindableNode;
function getNodeForReferences(node) {
    if (utils_1.TypeGuards.isIdentifier(node))
        return node;
    const nameNode = node.getNodeProperty("name");
    if (nameNode != null)
        return nameNode;
    if (utils_1.TypeGuards.isExportableNode(node))
        return node.getDefaultKeyword() || node;
    return node;
}
