"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const manipulation_1 = require("../../../manipulation");
const utils_1 = require("../../../utils");
const common_1 = require("../common");
class ClassElement extends common_1.Node {
    /**
     * Removes the class member.
     */
    remove() {
        const parent = this.getParent();
        if (utils_1.TypeGuards.isClassDeclaration(parent) || utils_1.TypeGuards.isClassExpression(parent))
            manipulation_1.removeClassMember(this);
        else if (utils_1.TypeGuards.isObjectLiteralExpression(parent))
            manipulation_1.removeCommaSeparatedChild(this);
        else
            errors.throwNotImplementedForSyntaxKindError(parent.getKind());
    }
}
exports.ClassElement = ClassElement;
