"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../common");
/**
 * JS doc tag node.
 */
class JSDocTag extends common_1.Node {
    /**
     * Gets the tag's name as a string.
     */
    getTagName() {
        return this.getTagNameNode().getText();
    }
    /**
     * Gets the tag name node.
     */
    getTagNameNode() {
        return this._getNodeFromCompilerNode(this.compilerNode.tagName);
    }
    /**
     * Gets the tag's comment.
     */
    getComment() {
        return this.compilerNode.comment;
    }
}
exports.JSDocTag = JSDocTag;
