"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const JSDocTag_1 = require("./JSDocTag");
/**
 * JS doc type tag node.
 */
class JSDocTypeTag extends JSDocTag_1.JSDocTag {
    /**
     * Gets the type expression node of the JS doc property type tag.
     */
    getTypeExpression() {
        // for some reason the compiler will still return a node when it doesn't exist
        const node = this.compilerNode.typeExpression;
        if (node != null && node.pos === node.end)
            return undefined;
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.typeExpression);
    }
}
exports.JSDocTypeTag = JSDocTypeTag;
