"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Expression_1 = require("./Expression");
exports.BinaryExpressionBase = Expression_1.Expression;
class BinaryExpression extends exports.BinaryExpressionBase {
    /**
     * Gets the left side of the binary expression.
     */
    getLeft() {
        return this._getNodeFromCompilerNode(this.compilerNode.left);
    }
    /**
     * Gets the operator token of the binary expression.
     */
    getOperatorToken() {
        return this._getNodeFromCompilerNode(this.compilerNode.operatorToken);
    }
    /**
     * Gets the right side of the binary expression.
     */
    getRight() {
        return this._getNodeFromCompilerNode(this.compilerNode.right);
    }
}
exports.BinaryExpression = BinaryExpression;
