"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const expressioned_1 = require("./expressioned");
const MemberExpression_1 = require("./MemberExpression");
exports.ElementAccessExpressionBase = expressioned_1.LeftHandSideExpressionedNode(MemberExpression_1.MemberExpression);
class ElementAccessExpression extends exports.ElementAccessExpressionBase {
    /**
     * Gets this element access expression's argument expression or undefined if none exists.
     */
    getArgumentExpression() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.argumentExpression);
    }
    /**
     * Gets this element access expression's argument expression or throws if none exists.
     */
    getArgumentExpressionOrThrow() {
        return errors.throwIfNullOrUndefined(this.getArgumentExpression(), "Expected to find an argument expression.");
    }
}
exports.ElementAccessExpression = ElementAccessExpression;
