"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const base_1 = require("../base");
const Expression_1 = require("./Expression");
exports.YieldExpressionBase = base_1.GeneratorableNode(Expression_1.Expression);
class YieldExpression extends exports.YieldExpressionBase {
    /**
     * Gets the expression or undefined of the yield expression.
     */
    getExpression() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.expression);
    }
    /**
     * Gets the expression of the yield expression or throws if it does not exist.
     */
    getExpressionOrThrow() {
        return errors.throwIfNullOrUndefined(this.getExpression(), "Expected to find an expression.");
    }
}
exports.YieldExpression = YieldExpression;
