"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const expressioned_1 = require("../expressioned");
const structures_1 = require("../../../../structures");
const callBaseSet_1 = require("../../callBaseSet");
const callBaseGetStructure_1 = require("../../callBaseGetStructure");
const ObjectLiteralElement_1 = require("./ObjectLiteralElement");
exports.SpreadAssignmentBase = expressioned_1.ExpressionedNode(ObjectLiteralElement_1.ObjectLiteralElement);
class SpreadAssignment extends exports.SpreadAssignmentBase {
    /**
     * Sets the node from a structure.
     * @param structure - Structure to set the node with.
     */
    set(structure) {
        callBaseSet_1.callBaseSet(exports.SpreadAssignmentBase.prototype, this, structure);
        return this;
    }
    /**
     * Gets the structure equivalent to this node.
     */
    getStructure() {
        return callBaseGetStructure_1.callBaseGetStructure(exports.SpreadAssignmentBase.prototype, this, {
            kind: structures_1.StructureKind.SpreadAssignment,
            expression: this.getExpression().getText() // todo: should this be moved down to the base? if not, explain in a comment here
        });
    }
}
exports.SpreadAssignment = SpreadAssignment;
