"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const structures_1 = require("../../../structures");
const base_1 = require("../base");
const callBaseSet_1 = require("../callBaseSet");
const TypeElement_1 = require("./TypeElement");
const callBaseGetStructure_1 = require("../callBaseGetStructure");
exports.MethodSignatureBase = base_1.ChildOrderableNode(base_1.JSDocableNode(base_1.QuestionTokenableNode(base_1.TypeParameteredNode(base_1.SignaturedDeclaration(base_1.PropertyNamedNode(TypeElement_1.TypeElement))))));
class MethodSignature extends exports.MethodSignatureBase {
    /**
     * Sets the node from a structure.
     * @param structure - Structure to set the node with.
     */
    set(structure) {
        callBaseSet_1.callBaseSet(exports.MethodSignatureBase.prototype, this, structure);
        return this;
    }
    /**
     * Gets the structure equivalent to this node.
     */
    getStructure() {
        return callBaseGetStructure_1.callBaseGetStructure(exports.MethodSignatureBase.prototype, this, {
            kind: structures_1.StructureKind.MethodSignature
        });
    }
}
exports.MethodSignature = MethodSignature;
