"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const expression_1 = require("../expression");
class JsxFragment extends expression_1.PrimaryExpression {
    /**
     * Gets the children of the JSX fragment.
     */
    getJsxChildren() {
        return this.compilerNode.children.map(c => this._getNodeFromCompilerNode(c));
    }
    /**
     * Gets the opening fragment.
     */
    getOpeningFragment() {
        return this._getNodeFromCompilerNode(this.compilerNode.openingFragment);
    }
    /**
     * Gets the closing fragment.
     */
    getClosingFragment() {
        return this._getNodeFromCompilerNode(this.compilerNode.closingFragment);
    }
}
exports.JsxFragment = JsxFragment;
