"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const structures_1 = require("../../../structures");
const callBaseGetStructure_1 = require("../callBaseGetStructure");
const callBaseSet_1 = require("../callBaseSet");
const expression_1 = require("../expression");
const base_1 = require("./base");
exports.JsxSelfClosingElementBase = base_1.JsxAttributedNode(base_1.JsxTagNamedNode(expression_1.PrimaryExpression));
class JsxSelfClosingElement extends exports.JsxSelfClosingElementBase {
    /**
     * Sets the node from a structure.
     * @param structure - Structure to set the node with.
     */
    set(structure) {
        callBaseSet_1.callBaseSet(exports.JsxSelfClosingElementBase.prototype, this, structure);
        return this;
    }
    /**
     * Gets the structure equivalent to this node.
     */
    getStructure() {
        return callBaseGetStructure_1.callBaseGetStructure(exports.JsxSelfClosingElementBase.prototype, this, {
            kind: structures_1.StructureKind.JsxSelfClosingElement
        });
    }
}
exports.JsxSelfClosingElement = JsxSelfClosingElement;
