"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../base");
const common_1 = require("../common");
exports.JsxTextBase = base_1.LiteralLikeNode(common_1.Node);
class JsxText extends exports.JsxTextBase {
    /**
     * Gets if the JSX text contains only white spaces.
     */
    containsOnlyTriviaWhiteSpaces() {
        // this is necessary for typescript < 3.4
        const oldCompilerNode = this.compilerNode;
        if (typeof oldCompilerNode.containsOnlyWhiteSpaces === "boolean")
            return oldCompilerNode.containsOnlyWhiteSpaces;
        return this.compilerNode.containsOnlyTriviaWhiteSpaces;
    }
}
exports.JsxText = JsxText;
