"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const callBaseSet_1 = require("../../callBaseSet");
const callBaseGetStructure_1 = require("../../callBaseGetStructure");
function JsxTagNamedNode(Base) {
    return class extends Base {
        /**
         * Gets the tag name of the JSX element.
         */
        getTagNameNode() {
            return this._getNodeFromCompilerNode(this.compilerNode.tagName);
        }
        set(structure) {
            callBaseSet_1.callBaseSet(Base.prototype, this, structure);
            if (structure.name != null)
                this.getTagNameNode().replaceWithText(structure.name);
            return this;
        }
        getStructure() {
            return callBaseGetStructure_1.callBaseGetStructure(Base.prototype, this, {
                name: this.getTagNameNode().getText()
            });
        }
    };
}
exports.JsxTagNamedNode = JsxTagNamedNode;
