"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const manipulation_1 = require("../../../manipulation");
const expression_1 = require("../expression");
exports.NumericLiteralBase = expression_1.LiteralExpression;
class NumericLiteral extends exports.NumericLiteralBase {
    /**
     * Gets the literal value.
     */
    getLiteralValue() {
        const text = this.compilerNode.text;
        if (text.indexOf(".") >= 0)
            return parseFloat(text);
        return parseInt(text, 10);
    }
    /**
     * Sets the literal value.
     * @param value - Value to set.
     */
    setLiteralValue(value) {
        manipulation_1.replaceNodeText({
            sourceFile: this._sourceFile,
            start: this.getStart(),
            replacingLength: this.getWidth(),
            newText: value.toString(10)
        });
        return this;
    }
}
exports.NumericLiteral = NumericLiteral;
