"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = require("../../../typescript");
const errors = require("../../../errors");
const utils_1 = require("../../../utils");
function NamespaceChildableNode(Base) {
    return class extends Base {
        getParentNamespaceOrThrow() {
            return errors.throwIfNullOrUndefined(this.getParentNamespace(), "Expected to find the parent namespace.");
        }
        getParentNamespace() {
            let parent = this.getParentOrThrow();
            if (!utils_1.TypeGuards.isModuleBlock(parent))
                return undefined;
            while (parent.getParentOrThrow().getKind() === typescript_1.SyntaxKind.ModuleDeclaration)
                parent = parent.getParentOrThrow();
            return parent;
        }
    };
}
exports.NamespaceChildableNode = NamespaceChildableNode;
