"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("../base");
const common_1 = require("../common");
exports.NamespaceImportBase = base_1.RenameableNode(common_1.Node);
class NamespaceImport extends exports.NamespaceImportBase {
    /**
     * Sets the name of the namespace import.
     */
    setName(name) {
        const nameNode = this.getNameNode();
        if (nameNode.getText() === name)
            return this;
        nameNode.replaceWithText(name);
        return this;
    }
    /**
     * Gets the name of the namespace import.
     */
    getName() {
        return this.getNameNode().getText();
    }
    /**
     * Gets the namespace import's name node.
     */
    getNameNode() {
        return this._getNodeFromCompilerNode(this.compilerNode.name);
    }
}
exports.NamespaceImport = NamespaceImport;
