"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const Statement_1 = require("./Statement");
class BreakStatement extends Statement_1.Statement {
    /**
     * Gets this break statement's label or undefined if it does not exist.
     */
    getLabel() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.label);
    }
    /**
     * Gets this break statement's label or throw if it does not exist.
     */
    getLabelOrThrow() {
        return errors.throwIfNullOrUndefined(this.getLabel(), "Expected to find a label.");
    }
}
exports.BreakStatement = BreakStatement;
