"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const manipulation_1 = require("../../../manipulation");
const base_1 = require("../base");
const common_1 = require("../common");
const StatementedNode_1 = require("./StatementedNode");
exports.CaseClauseBase = base_1.TextInsertableNode(StatementedNode_1.StatementedNode(common_1.Node));
class CaseClause extends exports.CaseClauseBase {
    /**
     * Gets this switch statement's expression.
     */
    getExpression() {
        return this._getNodeFromCompilerNode(this.compilerNode.expression);
    }
    /**
     * Removes this case clause.
     */
    remove() {
        manipulation_1.removeClausedNodeChild(this);
    }
}
exports.CaseClause = CaseClause;
