"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const common_1 = require("../common");
exports.CatchClauseBase = common_1.Node;
class CatchClause extends exports.CatchClauseBase {
    /**
     * Gets this catch clause's block.
     */
    getBlock() {
        return this._getNodeFromCompilerNode(this.compilerNode.block);
    }
    /**
     * Gets this catch clause's variable declaration or undefined if none exists.
     */
    getVariableDeclaration() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.variableDeclaration);
    }
    /**
     * Gets this catch clause's variable declaration or throws if none exists.
     */
    getVariableDeclarationOrThrow() {
        return errors.throwIfNullOrUndefined(this.getVariableDeclaration(), "Expected to find a variable declaration.");
    }
}
exports.CatchClause = CatchClause;
