"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../../errors");
const Statement_1 = require("./Statement");
class ReturnStatement extends Statement_1.Statement {
    /**
     * Gets this return statement's expression if it exists or throws.
     */
    getExpressionOrThrow() {
        return errors.throwIfNullOrUndefined(this.getExpression(), "Expected to find a return expression's expression.");
    }
    /**
     * Gets this return statement's expression if it exists.
     */
    getExpression() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.expression);
    }
}
exports.ReturnStatement = ReturnStatement;
