"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Statement_1 = require("./Statement");
const errors = require("../../../errors");
exports.ThrowStatementBase = Statement_1.Statement;
class ThrowStatement extends exports.ThrowStatementBase {
    /**
     * Gets the throw statement's expression.
     */
    getExpression() {
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.expression);
    }
    /**
     * Gets the throw statement's expression or throws undefined if it doesn't exist.
     */
    getExpressionOrThrow() {
        return errors.throwIfNullOrUndefined(this.getExpression(), "Expected to find the throw statement's expression.");
    }
}
exports.ThrowStatement = ThrowStatement;
