"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TypeNode_1 = require("./TypeNode");
class IndexedAccessTypeNode extends TypeNode_1.TypeNode {
    /**
     * Gets the indexed access type node's object type node.
     *
     * This is `MyObjectType` in `MyObjectType["myIndex"]`.
     */
    getObjectTypeNode() {
        return this._getNodeFromCompilerNode(this.compilerNode.objectType);
    }
    /**
     * Gets the indexed access type node's index type node.
     *
     * This is `"myIndex"` in `MyObjectType["myIndex"]`.
     */
    getIndexTypeNode() {
        return this._getNodeFromCompilerNode(this.compilerNode.indexType);
    }
}
exports.IndexedAccessTypeNode = IndexedAccessTypeNode;
