"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TypeNode_1 = require("./TypeNode");
class ParenthesizedTypeNode extends TypeNode_1.TypeNode {
    /**
     * Gets the node within the parentheses.
     */
    getTypeNode() {
        return this._getNodeFromCompilerNode(this.compilerNode.type);
    }
    /**
     * Sets the type within the parentheses.
     * @param textOrWriterFunction - Text or writer function to set the type with.
     */
    setType(textOrWriterFunction) {
        this.getTypeNode().replaceWithText(textOrWriterFunction);
        return this;
    }
}
exports.ParenthesizedTypeNode = ParenthesizedTypeNode;
