"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const structures_1 = require("../../../structures");
const base_1 = require("../base");
const callBaseSet_1 = require("../callBaseSet");
const statement_1 = require("../statement");
const callBaseGetStructure_1 = require("../callBaseGetStructure");
// todo: type node should not be able to return undefined
exports.TypeAliasDeclarationBase = base_1.TypeParameteredNode(base_1.TypedNode(base_1.JSDocableNode(base_1.AmbientableNode(base_1.ExportableNode(base_1.ModifierableNode(base_1.NamedNode(statement_1.Statement)))))));
class TypeAliasDeclaration extends exports.TypeAliasDeclarationBase {
    /**
     * Sets the node from a structure.
     * @param structure - Structure to set the node with.
     */
    set(structure) {
        callBaseSet_1.callBaseSet(exports.TypeAliasDeclarationBase.prototype, this, structure);
        return this;
    }
    /**
     * Gets the structure equivalent to this node.
     */
    getStructure() {
        return callBaseGetStructure_1.callBaseGetStructure(exports.TypeAliasDeclarationBase.prototype, this, {
            kind: structures_1.StructureKind.TypeAlias,
            type: this.getTypeNodeOrThrow().getText()
        });
    }
}
exports.TypeAliasDeclaration = TypeAliasDeclaration;
