"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FileTextChanges_1 = require("./FileTextChanges");
/**
 * Represents a code action.
 */
class CodeAction {
    /** @private */
    constructor(context, compilerObject) {
        this._context = context;
        this._compilerObject = compilerObject;
    }
    /** Gets the compiler object. */
    get compilerObject() {
        return this._compilerObject;
    }
    /** Description of the code action. */
    getDescription() {
        return this.compilerObject.description;
    }
    /** Text changes to apply to each file as part of the code action. */
    getChanges() {
        return this.compilerObject.changes.map(change => new FileTextChanges_1.FileTextChanges(this._context, change));
    }
}
exports.CodeAction = CodeAction;
