"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CodeAction_1 = require("./CodeAction");
/**
 * Represents a code fix action.
 */
class CodeFixAction extends CodeAction_1.CodeAction {
    /**
     * Short name to identify the fix, for use by telemetry.
     */
    getFixName() {
        return this.compilerObject.fixName;
    }
    /**
     * If present, one may call 'getCombinedCodeFix' with this fixId.
     * This may be omitted to indicate that the code fix can't be applied in a group.
     */
    getFixId() {
        return this.compilerObject.fixId;
    }
    /**
     * Gets the description of the code fix when fixing everything.
     */
    getFixAllDescription() {
        return this.compilerObject.fixAllDescription;
    }
}
exports.CodeFixAction = CodeFixAction;
