"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Output file of an emit.
 */
class OutputFile {
    /**
     * @private
     */
    constructor(context, compilerObject) {
        this._compilerObject = compilerObject;
        this._context = context;
    }
    /**
     * TypeScript compiler output file.
     */
    get compilerObject() {
        return this._compilerObject;
    }
    /**
     * Gets the file path.
     */
    getFilePath() {
        return this._context.fileSystemWrapper.getStandardizedAbsolutePath(this.compilerObject.name);
    }
    /**
     * Gets whether the byte order mark should be written.
     */
    getWriteByteOrderMark() {
        return this.compilerObject.writeByteOrderMark || false;
    }
    /**
     * Gets the file text.
     */
    getText() {
        return this.compilerObject.text;
    }
}
exports.OutputFile = OutputFile;
