"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../../utils");
const TextSpan_1 = require("./TextSpan");
/**
 * Represents a text change.
 */
class TextChange {
    /** @private */
    constructor(compilerObject) {
        this._compilerObject = compilerObject;
    }
    /** Gets the compiler text change. */
    get compilerObject() {
        return this._compilerObject;
    }
    /**
     * Gets the text span.
     */
    getSpan() {
        return new TextSpan_1.TextSpan(this.compilerObject.span);
    }
    /**
     * Gets the new text.
     */
    getNewText() {
        return this.compilerObject.newText;
    }
}
__decorate([
    utils_1.Memoize
], TextChange.prototype, "getSpan", null);
exports.TextChange = TextChange;
