"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Represents a span of text.
 */
class TextSpan {
    /** @private */
    constructor(compilerObject) {
        this._compilerObject = compilerObject;
    }
    /** Gets the compiler text span. */
    get compilerObject() {
        return this._compilerObject;
    }
    /**
     * Gets the start.
     */
    getStart() {
        return this.compilerObject.start;
    }
    /**
     * Gets the start + length.
     */
    getEnd() {
        return this.compilerObject.start + this.compilerObject.length;
    }
    /**
     * Gets the length.
     */
    getLength() {
        return this.compilerObject.length;
    }
}
exports.TextSpan = TextSpan;
