"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class RenameLocationTextManipulator {
    constructor(renameLocations, newName) {
        this.renameLocations = renameLocations;
        this.newName = newName;
    }
    getNewText(inputText) {
        // get the rename locations in reverse order
        const renameLocations = this.renameLocations.map(l => l.getTextSpan()).sort((a, b) => b.getStart() - a.getStart());
        let currentPos = inputText.length;
        let result = "";
        for (let i = 0; i < renameLocations.length; i++) {
            const textSpan = renameLocations[i];
            result = this.newName + inputText.substring(textSpan.getEnd(), currentPos) + result;
            currentPos = textSpan.getStart();
        }
        return inputText.substring(0, currentPos) + result;
    }
    getTextForError(newText) {
        if (this.renameLocations.length === 0)
            return newText;
        return "..." + newText.substring(this.renameLocations[0].getTextSpan().getStart());
    }
}
exports.RenameLocationTextManipulator = RenameLocationTextManipulator;
