"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Printer_1 = require("./Printer");
/** Printer for node structures. */
class NodePrinter extends Printer_1.Printer {
    constructor(factory) {
        super();
        this.factory = factory;
    }
    printText(writer, structure) {
        const typedStructure = structure;
        const leadingTrivia = typedStructure && typedStructure.leadingTrivia;
        const trailingTrivia = typedStructure && typedStructure.trailingTrivia;
        if (leadingTrivia != null) {
            printTrivia.call(this, leadingTrivia);
            if (writer.isInComment())
                writer.closeComment();
        }
        this.printTextInternal(writer, structure);
        if (trailingTrivia != null)
            printTrivia.call(this, trailingTrivia);
        function printTrivia(trivia) {
            if (trivia instanceof Array) {
                for (let i = 0; i < trivia.length; i++) {
                    this.printTextOrWriterFunc(writer, trivia[i]);
                    if (i !== trivia.length - 1)
                        writer.newLineIfLastNot();
                }
            }
            else {
                this.printTextOrWriterFunc(writer, trivia);
            }
        }
    }
}
exports.NodePrinter = NodePrinter;
