"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codeBlockWriter_1 = require("../codeBlockWriter");
class Printer {
    // todo: this should not be a method on the base
    printTextOrWriterFunc(writer, textOrWriterFunc) {
        if (typeof textOrWriterFunc === "string")
            writer.write(textOrWriterFunc);
        else if (textOrWriterFunc != null)
            textOrWriterFunc(writer);
    }
    getNewWriter(writer) {
        return new codeBlockWriter_1.CodeBlockWriter(writer.getOptions());
    }
    getNewWriterWithQueuedChildIndentation(writer) {
        const newWriter = new codeBlockWriter_1.CodeBlockWriter(writer.getOptions());
        newWriter.queueIndentationLevel(1);
        return newWriter;
    }
    getTextWithQueuedChildIndentation(writer, textOrWriterFunc) {
        const queuedChildIndentationWriter = this.getNewWriterWithQueuedChildIndentation(writer);
        if (typeof textOrWriterFunc === "string")
            queuedChildIndentationWriter.write(textOrWriterFunc);
        else
            textOrWriterFunc(queuedChildIndentationWriter);
        return queuedChildIndentationWriter.toString();
    }
}
exports.Printer = Printer;
