"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const Printer_1 = require("../Printer");
class InitializerExpressionableNodeStructurePrinter extends Printer_1.Printer {
    printText(writer, structure) {
        const { initializer } = structure;
        if (initializer == null)
            return;
        const initializerText = this.getTextWithQueuedChildIndentation(writer, initializer);
        if (!utils_1.StringUtils.isNullOrWhitespace(initializerText))
            writer.write(` = ${initializerText}`);
    }
}
exports.InitializerExpressionableNodeStructurePrinter = InitializerExpressionableNodeStructurePrinter;
