"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Printer_1 = require("../Printer");
class ModifierableNodeStructurePrinter extends Printer_1.Printer {
    printText(writer, structure) {
        const scope = structure.scope;
        if (structure.isDefaultExport)
            writer.write("export default ");
        else if (structure.isExported)
            writer.write("export ");
        if (structure.hasDeclareKeyword)
            writer.write("declare ");
        if (structure.isAbstract)
            writer.write("abstract ");
        if (scope != null)
            writer.write(`${scope} `);
        if (structure.isStatic)
            writer.write("static ");
        if (structure.isAsync)
            writer.write("async ");
        if (structure.isReadonly)
            writer.write("readonly ");
    }
}
exports.ModifierableNodeStructurePrinter = ModifierableNodeStructurePrinter;
