"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const Printer_1 = require("../Printer");
class ReturnTypedNodeStructurePrinter extends Printer_1.Printer {
    constructor(alwaysWrite = false) {
        super();
        this.alwaysWrite = alwaysWrite;
    }
    printText(writer, structure) {
        let { returnType } = structure;
        if (returnType == null && this.alwaysWrite === false)
            return;
        returnType = returnType || "void";
        const returnTypeText = this.getTextWithQueuedChildIndentation(writer, returnType);
        if (!utils_1.StringUtils.isNullOrWhitespace(returnTypeText))
            writer.write(`: ${returnTypeText}`);
    }
}
exports.ReturnTypedNodeStructurePrinter = ReturnTypedNodeStructurePrinter;
