"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const Printer_1 = require("../Printer");
class TypedNodeStructurePrinter extends Printer_1.Printer {
    constructor(separator, alwaysWrite = false) {
        super();
        this.separator = separator;
        this.alwaysWrite = alwaysWrite;
    }
    printText(writer, structure) {
        let { type } = structure;
        if (type == null && this.alwaysWrite === false)
            return;
        type = type || "any";
        const typeText = this.getTextWithQueuedChildIndentation(writer, type);
        if (!utils_1.StringUtils.isNullOrWhitespace(typeText))
            writer.write(`${this.separator} ${typeText}`);
    }
}
exports.TypedNodeStructurePrinter = TypedNodeStructurePrinter;
