"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codeBlockWriter_1 = require("../../codeBlockWriter");
const utils_1 = require("../../utils");
const NodePrinter_1 = require("../NodePrinter");
class JSDocStructurePrinter extends NodePrinter_1.NodePrinter {
    printDocs(writer, structures) {
        if (structures == null)
            return;
        for (const structure of structures) {
            this.printText(writer, structure);
            writer.newLine();
        }
    }
    printTextInternal(writer, structure) {
        const lines = getText().split(/\r?\n/);
        writer.writeLine("/**");
        for (const line of lines) {
            writer.write(` *`);
            if (line.length > 0)
                writer.write(` ${line}`);
            writer.newLine();
        }
        writer.write(" */");
        function getText() {
            if (typeof structure === "string")
                return structure;
            const tempWriter = new codeBlockWriter_1.CodeBlockWriter(writer.getOptions());
            if (typeof structure === "function") {
                structure(tempWriter);
                return tempWriter.toString();
            }
            return utils_1.getTextFromStringOrWriter(tempWriter, structure.description);
        }
    }
}
exports.JSDocStructurePrinter = JSDocStructurePrinter;
