"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Printer_1 = require("../Printer");
class CommaNewLineSeparatedStructuresPrinter extends Printer_1.Printer {
    constructor(printer) {
        super();
        this.printer = printer;
    }
    printText(writer, structures) {
        if (structures == null)
            return;
        if (structures instanceof Function)
            this.printer.printText(writer, structures);
        else
            for (let i = 0; i < structures.length; i++) {
                if (i > 0)
                    writer.write(",").newLine();
                this.printer.printText(writer, structures[i]);
            }
    }
}
exports.CommaNewLineSeparatedStructuresPrinter = CommaNewLineSeparatedStructuresPrinter;
