"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../errors");
const structures_1 = require("../../structures");
const NodePrinter_1 = require("../NodePrinter");
class JsxAttributeDeciderStructurePrinter extends NodePrinter_1.NodePrinter {
    printTextInternal(writer, structure) {
        if (isJsxAttribute(structure))
            this.factory.forJsxAttribute().printText(writer, structure);
        else if (structure.kind === structures_1.StructureKind.JsxSpreadAttribute)
            this.factory.forJsxSpreadAttribute().printText(writer, structure);
        else
            throw errors.throwNotImplementedForNeverValueError(structure);
        // need to help out the typescript compiler with this function for some reason
        function isJsxAttribute(struct) {
            return structure.kind == null || structure.kind === structures_1.StructureKind.JsxAttribute;
        }
    }
}
exports.JsxAttributeDeciderStructurePrinter = JsxAttributeDeciderStructurePrinter;
