"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors = require("../../errors");
const structures_1 = require("../../structures");
const NodePrinter_1 = require("../NodePrinter");
class JsxChildDeciderStructurePrinter extends NodePrinter_1.NodePrinter {
    printTextInternal(writer, structure) {
        if (isJsxElement(structure))
            this.factory.forJsxElement().printText(writer, structure);
        else if (structure.kind === structures_1.StructureKind.JsxSelfClosingElement)
            this.factory.forJsxSelfClosingElement().printText(writer, structure);
        else
            errors.throwNotImplementedForNeverValueError(structure);
        // need to help out the typescript compiler with this function for some reason
        function isJsxElement(struct) {
            return struct.kind == null || struct.kind === structures_1.StructureKind.JsxElement;
        }
    }
}
exports.JsxChildDeciderStructurePrinter = JsxChildDeciderStructurePrinter;
