"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const NodePrinter_1 = require("../NodePrinter");
class JsxElementStructurePrinter extends NodePrinter_1.NodePrinter {
    printTextInternal(writer, structure) {
        writer.write(`<${structure.name}`);
        if (structure.attributes)
            this.printAttributes(writer, structure.attributes);
        writer.write(">");
        this.printChildren(writer, structure.children);
        writer.write(`</${structure.name}>`);
    }
    printAttributes(writer, attributes) {
        const attributePrinter = this.factory.forJsxAttributeDecider();
        for (const attrib of attributes) {
            writer.space();
            attributePrinter.printText(writer, attrib);
        }
    }
    printChildren(writer, children) {
        if (children == null)
            return;
        writer.newLine();
        writer.indentBlock(() => {
            for (const child of children) {
                this.factory.forJsxChildDecider().printText(writer, child);
                writer.newLine();
            }
        });
    }
}
exports.JsxElementStructurePrinter = JsxElementStructurePrinter;
