"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const NodePrinter_1 = require("../NodePrinter");
class JsxSelfClosingElementStructurePrinter extends NodePrinter_1.NodePrinter {
    printTextInternal(writer, structure) {
        writer.write(`<${structure.name}`);
        if (structure.attributes)
            this.printAttributes(writer, structure.attributes);
        writer.write(" />");
    }
    printAttributes(writer, attributes) {
        const attributePrinter = this.factory.forJsxAttributeDecider();
        for (const attrib of attributes) {
            writer.space();
            attributePrinter.printText(writer, attrib);
        }
    }
}
exports.JsxSelfClosingElementStructurePrinter = JsxSelfClosingElementStructurePrinter;
