"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const VariableDeclarationKind_1 = require("../../compiler/ast/variable/VariableDeclarationKind");
const NodePrinter_1 = require("../NodePrinter");
const formatting_1 = require("../formatting");
class VariableStatementStructurePrinter extends NodePrinter_1.NodePrinter {
    constructor() {
        super(...arguments);
        this.multipleWriter = new formatting_1.NewLineFormattingStructuresPrinter(this);
    }
    printTexts(writer, structures) {
        this.multipleWriter.printText(writer, structures);
    }
    printTextInternal(writer, structure) {
        this.factory.forJSDoc().printDocs(writer, structure.docs);
        this.factory.forModifierableNode().printText(writer, structure);
        writer.write(`${structure.declarationKind || VariableDeclarationKind_1.VariableDeclarationKind.Let} `);
        this.factory.forVariableDeclaration().printTexts(writer, structure.declarations);
        writer.write(";");
    }
}
exports.VariableStatementStructurePrinter = VariableStatementStructurePrinter;
