"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const NodePrinter_1 = require("../NodePrinter");
const formatting_1 = require("../formatting");
class TypeParameterDeclarationStructurePrinter extends NodePrinter_1.NodePrinter {
    constructor() {
        super(...arguments);
        this.multipleWriter = new formatting_1.CommaSeparatedStructuresPrinter(this);
    }
    printTextsWithBrackets(writer, structures) {
        if (structures == null || structures.length === 0)
            return;
        writer.write("<");
        this.printTexts(writer, structures);
        writer.write(">");
    }
    printTexts(writer, structures) {
        this.multipleWriter.printText(writer, structures);
    }
    printTextInternal(writer, structure) {
        if (typeof structure === "string") {
            writer.write(structure);
            return;
        }
        writer.write(structure.name);
        if (structure.constraint != null) {
            const constraintText = this.getTextWithQueuedChildIndentation(writer, structure.constraint);
            if (!utils_1.StringUtils.isNullOrWhitespace(constraintText))
                writer.write(` extends ${constraintText}`);
        }
        if (structure.default != null) {
            const defaultText = this.getTextWithQueuedChildIndentation(writer, structure.default);
            if (!utils_1.StringUtils.isNullOrWhitespace(defaultText))
                writer.write(` = ${defaultText}`);
        }
    }
}
exports.TypeParameterDeclarationStructurePrinter = TypeParameterDeclarationStructurePrinter;
