"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = require("../../typescript");
function getSyntaxKindName(kind) {
    return getKindCache()[kind];
}
exports.getSyntaxKindName = getSyntaxKindName;
let kindCache = undefined;
function getKindCache() {
    if (kindCache != null)
        return kindCache;
    kindCache = {};
    // some SyntaxKinds are repeated, so only use the first one
    for (const name of Object.keys(typescript_1.SyntaxKind).filter(k => isNaN(parseInt(k, 10)))) {
        const value = typescript_1.SyntaxKind[name];
        if (kindCache[value] == null)
            kindCache[value] = name;
    }
    return kindCache;
}
