"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = require("../../typescript");
const TypeGuards_1 = require("../TypeGuards");
function isNodeAmbientOrInAmbientContext(node) {
    if (checkNodeIsAmbient(node) || node._sourceFile.isDeclarationFile())
        return true;
    for (const ancestor of node._getAncestorsIterator(false)) {
        if (checkNodeIsAmbient(ancestor))
            return true;
    }
    return false;
}
exports.isNodeAmbientOrInAmbientContext = isNodeAmbientOrInAmbientContext;
function checkNodeIsAmbient(node) {
    const isThisAmbient = (node.getCombinedModifierFlags() & typescript_1.ts.ModifierFlags.Ambient) === typescript_1.ts.ModifierFlags.Ambient;
    return isThisAmbient || TypeGuards_1.TypeGuards.isInterfaceDeclaration(node) || TypeGuards_1.TypeGuards.isTypeAliasDeclaration(node);
}
