"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const multimatch = require("multimatch");
const FileUtils_1 = require("./FileUtils");
function matchGlobs(paths, patterns, cwd) {
    if (typeof patterns === "string")
        patterns = FileUtils_1.FileUtils.toAbsoluteGlob(patterns, cwd);
    else
        patterns = patterns.map(p => FileUtils_1.FileUtils.toAbsoluteGlob(p, cwd));
    // @types/multimatch incorrectly specifies `string[]` type despite not modifying the array
    return multimatch(paths, patterns);
}
exports.matchGlobs = matchGlobs;
