"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fileSystem_1 = require("../../fileSystem");
const TsConfigResolver_1 = require("./TsConfigResolver");
/**
 * Gets the compiler options from a specified tsconfig.json
 * @param filePath - File path to the tsconfig.json.
 * @param options - Options.
 */
function getCompilerOptionsFromTsConfig(filePath, options = {}) {
    // remember, this is a public function
    const fileSystemWrapper = new fileSystem_1.FileSystemWrapper(options.fileSystem || new fileSystem_1.DefaultFileSystemHost());
    const tsConfigResolver = new TsConfigResolver_1.TsConfigResolver(fileSystemWrapper, filePath, options.encoding || "utf-8");
    return {
        options: tsConfigResolver.getCompilerOptions(),
        errors: tsConfigResolver.getErrors()
    };
}
exports.getCompilerOptionsFromTsConfig = getCompilerOptionsFromTsConfig;
